//********************************************************************
//*** Thread/PosixMutex.t.cc
//*** Copyright (c) 2002-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: PosixMutex.t.cc,v 1.12 2009-03-02 14:16:46 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "Thread/PosixMutex.hh"
#include "Thread/LockStatistics.hh"
#include "Exceptions/Errno.hh"
#include <string>
#include <stdio.h>

using namespace fatalmind;

void TEST_mutex_construct() {
	class PosixMutex<> mut;
}

void TEST_mutex_lock_free() {
	class PosixMutex<> mut;

	mut.lock();
	mut.unlock();
}

void TEST_PERF_mutex_lock() {
	class PosixMutex<> m;
	int i;

	for (i=0; i < 1000; ++i) {
			m.lock();
			m.unlock();
	}
}
